#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators
{
	public class CPAdx : Indicator
	{
			private int			nA = 0;
			private int			Ma = 0;
			private int			x = 0;
	
				
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "CPAdx";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
				FinalPeriod									= 14;
				Filter										= 200;
								AddPlot(Brushes.Orange, "CSaxd");
			}
			else if (State == State.Configure)
			{
				
				
			}
		}

		protected override void OnBarUpdate()
		
		{
			
			int step = FinalPeriod/20;
			for (int x = 10; x < FinalPeriod+1; x+=step)    
		
		
								
       		if (Slope(ADX(x),Filter,0)<0)
            {
				Ma = Ma+1;
				
			}
				
                nA = nA+1;  
                      

 			Value[0] = (((double)Ma/nA)*100);

			{
				 if (Value[0]<80)
			 {
            				 
					BackBrush=Brushes.Salmon;
			 }
     			 else
			 {

                  BackBrush=Brushes.Aquamarine;
			 }
     		
            
	  		}	
		
		}
	
			
	
			
		#region Properties
		[NinjaScriptProperty]
		[Range(0, int.MaxValue)]
		[Display(Name="FinalPeriod", Description="Number of ADX bars", Order=1, GroupName="Parameters")]
		public int FinalPeriod
		{ get; set; }
				
		[NinjaScriptProperty]
		[Range(1, int.MaxValue)]
		[Display(Name="Filter", Description="Slope calculation [n] bars", Order=2, GroupName="Parameters")]
		public int Filter
		{ get; set; }

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> CSadx
		{
			get { return Values[0]; }
		}
		#endregion
		
	}
	

}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private CPAdx[] cacheCPAdx;
		public CPAdx CPAdx(int finalPeriod, int filter)
		{
			return CPAdx(Input, finalPeriod, filter);
		}

		public CPAdx CPAdx(ISeries<double> input, int finalPeriod, int filter)
		{
			if (cacheCPAdx != null)
				for (int idx = 0; idx < cacheCPAdx.Length; idx++)
					if (cacheCPAdx[idx] != null && cacheCPAdx[idx].FinalPeriod == finalPeriod && cacheCPAdx[idx].Filter == filter && cacheCPAdx[idx].EqualsInput(input))
						return cacheCPAdx[idx];
			return CacheIndicator<CPAdx>(new CPAdx(){ FinalPeriod = finalPeriod, Filter = filter }, input, ref cacheCPAdx);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.CPAdx CPAdx(int finalPeriod, int filter)
		{
			return indicator.CPAdx(Input, finalPeriod, filter);
		}

		public Indicators.CPAdx CPAdx(ISeries<double> input , int finalPeriod, int filter)
		{
			return indicator.CPAdx(input, finalPeriod, filter);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.CPAdx CPAdx(int finalPeriod, int filter)
		{
			return indicator.CPAdx(Input, finalPeriod, filter);
		}

		public Indicators.CPAdx CPAdx(ISeries<double> input , int finalPeriod, int filter)
		{
			return indicator.CPAdx(input, finalPeriod, filter);
		}
	}
}

#endregion
